(function(dependencies,module){"use strict";if(typeof define==="function"&&define.amd){return define(dependencies,module)}if(typeof exports==="object"){return module(exports,require("jio"),require("complex_queries"))}window.local_storage={};module(window.local_storage,jIO,complex_queries)})(["exports","jio","complex_queries"],function(exports,jIO,complex_queries){"use strict";function objectIsEmpty(obj){var k;for(k in obj){if(obj.hasOwnProperty(k)){return false}}return true}var ram={},memorystorage,localstorage;localstorage={getItem:function(item){var value=localStorage.getItem(item);return value===null?null:JSON.parse(value)},setItem:function(item,value){return localStorage.setItem(item,JSON.stringify(value))},removeItem:function(item){return localStorage.removeItem(item)}};memorystorage={getItem:function(item){var value=ram[item];return value===undefined?null:JSON.parse(value)},setItem:function(item,value){ram[item]=JSON.stringify(value)},removeItem:function(item){delete ram[item]}};function LocalStorage(spec){if(typeof spec.username!=="string"&&!spec.username){throw new TypeError("LocalStorage 'username' must be a string "+"which contains more than one character.")}this._localpath="jio/localstorage/"+spec.username+"/"+(spec.application_name===null||spec.application_name===undefined?"untitled":spec.application_name.toString());switch(spec.mode){case"memory":this._database=ram;this._storage=memorystorage;this._mode="memory";break;default:this._database=localStorage;this._storage=localstorage;this._mode="localStorage";break}}LocalStorage.prototype.post=function(command,metadata){var doc,doc_id=metadata._id;if(!doc_id){doc_id=jIO.util.generateUuid()}doc=this._storage.getItem(this._localpath+"/"+doc_id);if(doc===null){doc=jIO.util.deepClone(metadata);doc._id=doc_id;delete doc._attachments;this._storage.setItem(this._localpath+"/"+doc_id,doc);command.success({id:doc_id})}else{command.error("conflict","document exists","Cannot create a new document")}};LocalStorage.prototype.put=function(command,metadata){var doc,tmp,status;doc=this._storage.getItem(this._localpath+"/"+metadata._id);if(doc===null){doc=jIO.util.deepClone(metadata);delete doc._attachments;status="created"}else{tmp=jIO.util.deepClone(metadata);tmp._attachments=doc._attachments;doc=tmp;status="no_content"}this._storage.setItem(this._localpath+"/"+metadata._id,doc);command.success(status)};LocalStorage.prototype.putAttachment=function(command,param){var that=this,doc,status="created";doc=this._storage.getItem(this._localpath+"/"+param._id);if(doc===null){return command.error("not_found","missing","Impossible to add attachment")}jIO.util.readBlobAsBinaryString(param._blob).then(function(e){doc._attachments=doc._attachments||{};if(doc._attachments[param._attachment]){status="no_content"}doc._attachments[param._attachment]={content_type:param._blob.type,digest:jIO.util.makeBinaryStringDigest(e.target.result),length:param._blob.size};that._storage.setItem(that._localpath+"/"+param._id+"/"+param._attachment,e.target.result);that._storage.setItem(that._localpath+"/"+param._id,doc);command.success(status,{digest:doc._attachments[param._attachment].digest})},function(e){command.error("request_timeout","blob error","Error "+e.status+", unable to get blob content")},function(e){command.notify(e.loaded/e.total*100)})};LocalStorage.prototype.get=function(command,param){var doc=this._storage.getItem(this._localpath+"/"+param._id);if(doc!==null){command.success({data:doc})}else{command.error("not_found","missing","Cannot find document")}};LocalStorage.prototype.getAttachment=function(command,param){var doc;doc=this._storage.getItem(this._localpath+"/"+param._id);if(doc===null){return command.error("not_found","missing document","Cannot find document")}if(typeof doc._attachments!=="object"||typeof doc._attachments[param._attachment]!=="object"){return command.error("not_found","missing attachment","Cannot find attachment")}command.success({data:this._storage.getItem(this._localpath+"/"+param._id+"/"+param._attachment)||"",digest:doc._attachments[param._attachment].digest,content_type:doc._attachments[param._attachment].content_type||""})};LocalStorage.prototype.remove=function(command,param){var doc,i,attachment_list;doc=this._storage.getItem(this._localpath+"/"+param._id);attachment_list=[];if(doc!==null&&typeof doc==="object"){if(typeof doc._attachments==="object"){for(i in doc._attachments){if(doc._attachments.hasOwnProperty(i)){attachment_list.push(i)}}}}else{return command.error("not_found","missing","Document not found")}this._storage.removeItem(this._localpath+"/"+param._id);for(i=0;i<attachment_list.length;i+=1){this._storage.removeItem(this._localpath+"/"+param._id+"/"+attachment_list[i])}command.success()};LocalStorage.prototype.removeAttachment=function(command,param){var doc=this._storage.getItem(this._localpath+"/"+param._id);if(typeof doc!=="object"){return command.error("not_found","missing document","Document not found")}if(typeof doc._attachments!=="object"||typeof doc._attachments[param._attachment]!=="object"){return command.error("not_found","missing attachment","Attachment not found")}delete doc._attachments[param._attachment];if(objectIsEmpty(doc._attachments)){delete doc._attachments}this._storage.setItem(this._localpath+"/"+param._id,doc);this._storage.removeItem(this._localpath+"/"+param._id+"/"+param._attachment);command.success()};LocalStorage.prototype.allDocs=function(command,param,options){var i,row,path_re,rows,document_list,document_object,delete_id;param.unused=true;rows=[];document_list=[];path_re=new RegExp("^"+complex_queries.stringEscapeRegexpCharacters(this._localpath)+"/[^/]+$");if(options.query===undefined&&options.sort_on===undefined&&options.select_list===undefined&&options.include_docs===undefined){rows=[];for(i in this._database){if(this._database.hasOwnProperty(i)){if(path_re.test(i)){row={value:{}};row.id=i.split("/").slice(-1)[0];row.key=row.id;if(options.include_docs){row.doc=JSON.parse(this._storage.getItem(i))}rows.push(row)}}}command.success({data:{rows:rows,total_rows:rows.length}})}else{for(i in this._database){if(this._database.hasOwnProperty(i)){if(path_re.test(i)){document_list.push(this._storage.getItem(i))}}}options.select_list=options.select_list||[];if(options.select_list.indexOf("_id")===-1){options.select_list.push("_id");delete_id=true}if(options.include_docs===true){document_object={};document_list.forEach(function(meta){document_object[meta._id]=meta})}complex_queries.QueryFactory.create(options.query||"").exec(document_list,options);document_list=document_list.map(function(value){var o={id:value._id,key:value._id};if(options.include_docs===true){o.doc=document_object[value._id];delete document_object[value._id]}if(delete_id){delete value._id}o.value=value;return o});command.success({data:{total_rows:document_list.length,rows:document_list}})}};LocalStorage.prototype.check=function(command,param){this.genericRepair(command,param,false)};LocalStorage.prototype.repair=function(command,param){this.genericRepair(command,param,true)};LocalStorage.prototype.genericRepair=function(command,param,repair){var that=this,result;function referenceAttachment(param,attachment){if(param.referenced_attachments.indexOf(attachment)!==-1){return}var i=param.unreferenced_attachments.indexOf(attachment);if(i!==-1){param.unreferenced_attachments.splice(i,1)}param.referenced_attachments[param.referenced_attachments.length]=attachment}function attachmentFound(param,attachment){if(param.referenced_attachments.indexOf(attachment)!==-1){return}if(param.unreferenced_attachments.indexOf(attachment)!==-1){return}param.unreferenced_attachments[param.unreferenced_attachments.length]=attachment}function repairOne(param,repair){var i,doc,modified;doc=that._storage.getItem(that._localpath+"/"+param._id);if(doc===null){return}if(typeof doc!=="object"){if(!repair){return{error:true,answers:["conflict","corrupted","Document is unrecoverable"]}}that._storage.removeItem(that._localpath+"/"+param._id);return}if(!repair){if(!new jIO.Metadata(doc).check()){return{error:true,answers:["conflict","corrupted","Some metadata might be lost"]}}}else{modified=jIO.util.uniqueJSONStringify(doc)!==jIO.util.uniqueJSONStringify(new jIO.Metadata(doc).format()._dict)}if(doc._attachments!==undefined){if(typeof doc._attachments!=="object"){if(!repair){return{error:true,answers:["conflict","corrupted","Attachments are unrecoverable"]}}delete doc._attachments;that._storage.setItem(that._localpath+"/"+param._id,doc);return}for(i in doc._attachments){if(doc._attachments.hasOwnProperty(i)){if(that._storage.getItem(that._localpath+"/"+param._id+"/"+i)!=="string"){if(!repair){return{error:true,answers:["conflict","missing attachment",'Attachment "'+i+'" of "'+param._id+'" is missing']}}delete doc._attachments[i];if(objectIsEmpty(doc._attachments)){delete doc._attachments}modified=true}else{referenceAttachment(param,param._id+"/"+doc._attachments[i]);if(doc._attachments[i].length!==undefined&&typeof doc._attachments[i].length!=="number"){if(!repair){return{error:true,answers:["conflict","corrupted","Attachment metadata length corrupted"]}}delete doc._attachments[i].length}}}}}if(modified){that._storage.setItem(that._localpath+"/"+param._id,doc)}}function repairAll(param,repair){var i,result;for(i in that._database){if(that._database.hasOwnProperty(i)){if(i.slice(0,that._localpath.length)===that._localpath){if(/^[^\/]+\/[^\/]+$/.test(i.slice(that._localpath.length+1))){attachmentFound(param,i.slice(that._localpath.length+1))}else if(/^[^\/]+$/.test(i.slice(that._localpath.length+1))){param._id=i.slice(that._localpath.length+1);result=repairOne(param,repair);if(result){return result}}else{that._storage.removeItem(i)}}}}for(i=0;i<param.unreferenced_attachments.length;i+=1){that._storage.removeItem(that._localpath+"/"+param.unreferenced_attachments[i])}}param.referenced_attachments=[];param.unreferenced_attachments=[];if(typeof param._id==="string"){result=repairOne(param,repair)||{}}else{result=repairAll(param,repair)||{}}if(result.error){return command.error.apply(command,result.answers||[])}command.success.apply(command,result.answers||[])};jIO.addStorage("local",LocalStorage);function createLocalDescription(username,application_name){if(typeof username!=="string"){throw new TypeError("LocalStorage username must be a string")}var description={type:"local",username:username};if(typeof application_name==="string"){description.application_name=application_name}return description}function createMemoryDescription(username,application_name){var description=createLocalDescription(username,application_name);description.mode="memory";return description}function createDescription(username,application_name,mode){if(mode===undefined||mode.toString()==="localStorage"){return createLocalDescription(username,application_name)}if(mode.toString()==="memory"){return createMemoryDescription(username,application_name)}throw new TypeError("Unknown LocalStorage '"+mode.toString()+"' mode")}exports.createDescription=createDescription;exports.createLocalDescription=createLocalDescription;exports.createMemoryDescription=createMemoryDescription;function clearLocalStorage(){var k;for(k in localStorage){if(localStorage.hasOwnProperty(k)){if(/^jio\/localstorage\//.test(k)){localStorage.removeItem(k)}}}}function clearMemoryStorage(){jIO.util.dictClear(ram)}exports.clear=clearLocalStorage;exports.clearLocalStorage=clearLocalStorage;exports.clearMemoryStorage=clearMemoryStorage});