(function(root,dependencies,factory){"use strict";if(typeof define==="function"&&define.amd){return define(dependencies,function(){return factory(require)})}if(typeof require==="function"){module.exports=factory(require);return}root.replicate_storage=factory(function(name){return{jio:jIO,rsvp:RSVP}[name]})})(this,["jio","rsvp"],function(require){"use strict";var Promise=require("rsvp").Promise,all=require("rsvp").all,dictUpdate=require("jio").util.dictUpdate,addStorageFunction=require("jio").addStorage;function isDate(date){if(!isNaN(new Date(date===null?undefined:date).getTime())){return true}return false}function sequence(then_list){var promise_list=[];return new Promise(function(resolve,reject,notify){var i,length=then_list.length;promise_list[0]=new Promise(function(resolve){resolve()});for(i=0;i<length;i+=1){if(Array.isArray(then_list[i])){promise_list[i+1]=promise_list[i].then(then_list[i][0],then_list[i][1],then_list[i][2])}else{promise_list[i+1]=promise_list[i].then(then_list[i])}}promise_list[i].then(resolve,reject,notify)},function(){var i,length=promise_list.length;for(i=0;i<length;i+=1){promise_list[i].cancel()}})}function success(promise){return new Promise(function(resolve,reject,notify){promise.then(resolve,resolve,notify)},function(){promise.cancel()})}function last(promise_list){var length=promise_list.length;promise_list=promise_list.slice();return new Promise(function(resolve,reject,notify){var index,last_answer,count=0,error_count=0;function resolver(){return function(answer){count+=1;if(count===length){return resolve(answer)}last_answer=answer}}function rejecter(){return function(answer){error_count+=1;if(error_count===length){return reject(answer)}count+=1;if(count===length){return resolve(last_answer)}}}function notifier(index){return function(notification){notify({index:index,value:notification})}}for(index=0;index<length;index+=1){promise_list[index].then(resolver(),rejecter(),notifier(index))}},function(){var index;for(index=0;index<length;index+=1){promise_list[index].cancel()}})}function lastModified(promise_list){var length=promise_list.length;promise_list=promise_list.slice();return new Promise(function(resolve,reject,notify){var index,last_good_answer,last_answer,count=0,error_count=0;function resolver(answer){last_answer=answer;if(last_good_answer===undefined){if(isDate(answer.data.modified)){last_good_answer=answer}}else{if(isDate(answer.data.modified)){if(new Date(last_good_answer.data.modified)<new Date(answer.data.modified)){last_good_answer=answer}}}count+=1;if(count===length){return resolve(last_good_answer)}}function rejecter(answer){error_count+=1;if(error_count===length){return reject(answer)}count+=1;if(count===length){return resolve(last_good_answer||last_answer)}}function notifier(index){return function(notification){notify({index:index,value:notification})}}for(index=0;index<length;index+=1){promise_list[index].then(resolver,rejecter,notifier(index))}},function(){var index;for(index=0;index<length;index+=1){promise_list[index].cancel()}})}function ReplicateStorage(spec){if(!Array.isArray(spec.storage_list)){throw new TypeError("ReplicateStorage(): "+"storage_list is not of type array")}this._storage_list=spec.storage_list}ReplicateStorage.prototype.post=function(command,metadata,option){var promise_list=[],index,length=this._storage_list.length;if(!isDate(metadata.modified)){command.error(409,"invalid 'modified' metadata","The metadata 'modified' should be a valid date string or date object");return}for(index=0;index<length;index+=1){promise_list[index]=success(command.storage(this._storage_list[index]).post(metadata,option))}sequence([function(){return last(promise_list)},[command.success,command.error]])};ReplicateStorage.prototype.put=function(command,metadata,option){var promise_list=[],index,length=this._storage_list.length;if(!isDate(metadata.modified)){command.error(409,"invalid 'modified' metadata","The metadata 'modified' should be a valid date string or date object");return}for(index=0;index<length;index+=1){promise_list[index]=command.storage(this._storage_list[index]).put(metadata,option)}sequence([function(){return last(promise_list)},[command.success,command.error]])};ReplicateStorage.prototype.putAttachment=function(command,param,option){var promise_list=[],index,length=this._storage_list.length;for(index=0;index<length;index+=1){promise_list[index]=success(command.storage(this._storage_list[index]).putAttachment(param,option))}sequence([function(){return last(promise_list)},[command.success,command.error]])};ReplicateStorage.prototype.remove=function(command,param,option){var promise_list=[],index,length=this._storage_list.length;for(index=0;index<length;index+=1){promise_list[index]=success(command.storage(this._storage_list[index]).remove(param,option))}sequence([function(){return last(promise_list)},[command.success,command.error]])};ReplicateStorage.prototype.removeAttachment=function(command,param,option){var promise_list=[],index,length=this._storage_list.length;for(index=0;index<length;index+=1){promise_list[index]=success(command.storage(this._storage_list[index]).removeAttachment(param,option))}sequence([function(){return last(promise_list)},[command.success,command.error]])};ReplicateStorage.prototype.get=function(command,param,option){var promise_list=[],index,length=this._storage_list.length;for(index=0;index<length;index+=1){promise_list[index]=command.storage(this._storage_list[index]).get(param,option)}sequence([function(){return lastModified(promise_list)},[command.success,command.error]])};ReplicateStorage.prototype.getAttachment=function(command,param,option){var promise_list=[],index,length=this._storage_list.length;for(index=0;index<length;index+=1){promise_list[index]=success(command.storage(this._storage_list[index]).getAttachment(param,option))}sequence([function(){return last(promise_list)},[command.success,command.error]])};ReplicateStorage.prototype.allDocs=function(command,param,option){var promise_list=[],index,length=this._storage_list.length;for(index=0;index<length;index+=1){promise_list[index]=success(command.storage(this._storage_list[index]).allDocs(option))}sequence([function(){return all(promise_list)},function(answers){var i,j,k,found,rows;for(i=0;i<answers.length;i+=1){if(answers[i].result==="success"){if(!rows){rows=answers[i].data.rows}else{for(j=0;j<answers[i].data.rows.length;j+=1){found=false;for(k=0;k<rows.length;k+=1){if(rows[k].id===answers[i].data.rows[j].id){found=true;break}}if(!found){rows.push(answers[i].data.rows[j])}}}}}return{data:{total_rows:(rows||[]).length,rows:rows||[]}}},[command.success,command.error]])};ReplicateStorage.prototype.check=function(command,param,option){var promise_list=[],index,length=this._storage_list.length;for(index=0;index<length;index+=1){promise_list[index]=success(command.storage(this._storage_list[index]).check(param,option))}sequence([function(){return all(promise_list)},[command.success,command.error]])};ReplicateStorage.prototype.repair=function(command,param){var promise_list=[],index,that,length=this._storage_list.length;that=this;if(typeof param._id!=="string"||!param._id){command.success();return}for(index=0;index<length;index+=1){promise_list[index]=success(command.storage(this._storage_list[index]).get(param))}sequence([function(){return all(promise_list)},function(answers){var i,list=[],winner=null;for(i=0;i<answers.length;i+=1){if(answers[i].result==="success"){if(isDate(answers[i].data.modified)){list[i]=answers[i].data;if(winner===null||new Date(winner.modified)<new Date(answers[i].data.modified)){winner=answers[i].data}}}else if(answers[i].status===404){list[i]=0}}for(i=0;i<list.length;i+=1){if(list[i]&&new Date(list[i].modified)<new Date(winner.modified)){list[i]=success(command.storage(that._storage_list[i]).put(winner))}else if(list[i]===0){list[i]=dictUpdate({},winner);delete list[i]._id;list[i]=success(command.storage(that._storage_list[i]).post(list[i]))}}list=list.reduce(function(previous,current){if(current){previous.push(current)}return previous},[]);return all(list)},function(answers){var i;for(i=0;i<answers.length;i+=1){if(answers[i].result!=="success"){return command.error(409)}}command.success()}])};addStorageFunction("replicate",ReplicateStorage)});